"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MangoMintsRedemptionClient = exports.MANGO_MINTS_REDEMPTION_ID = void 0;
const anchor_1 = require("@coral-xyz/anchor");
const Token = __importStar(require("@solana/spl-token"));
const mango_mints_redemption_1 = require("../../target/types/mango_mints_redemption");
const distribution_1 = require("./accounts/distribution");
// TODO
// Edit distribution
// Close claims accounts for expired distributions
// Close distributions that have not yet started
exports.MANGO_MINTS_REDEMPTION_ID = new anchor_1.web3.PublicKey('3BUZXy9mPcsSCoxJQiBu2xxpMP6HEvFMZbaL5CAWwLUf'); // TODO: ID
class MangoMintsRedemptionClient {
    constructor(provider, programId = exports.MANGO_MINTS_REDEMPTION_ID) {
        this.provider = provider;
        this.programId = programId;
        this.program = new anchor_1.Program(mango_mints_redemption_1.IDL, programId, provider);
    }
    loadDistribution(number) {
        return __awaiter(this, void 0, void 0, function* () {
            const distributionNum = Buffer.alloc(4);
            distributionNum.writeUint32LE(number);
            const [publicKey] = yield anchor_1.web3.PublicKey.findProgramAddress([Buffer.from('Distribution'), distributionNum], this.programId);
            const distribution = yield this.loadDistributionFromPublicKey(publicKey);
            console.log(distribution);
            yield distribution.loadMetadata();
            return distribution;
        });
    }
    loadDistributionFromPublicKey(publicKey) {
        return __awaiter(this, void 0, void 0, function* () {
            const distribution = yield this.program.account.distribution.fetch(publicKey);
            return new distribution_1.Distribution(this.programId, this.program, publicKey, distribution.distributionNum, distribution.merkleRoot, distribution.authority, distribution.start, distribution.duration, distribution.metadata);
        });
    }
    createDistribution(number, authority = this.provider.wallet.publicKey, start, duration, metadata, metadataUrl) {
        return __awaiter(this, void 0, void 0, function* () {
            const distribution = distribution_1.Distribution.findAddress(number, this.programId);
            const merkleTree = metadata.toMerkleTree();
            const metadataUrlBuf = Buffer.alloc(256);
            metadataUrlBuf.write(metadataUrl);
            yield this.program.methods
                .distributionCreate(number, [...merkleTree.getRoot()], new anchor_1.BN(start.getTime() / 1000), new anchor_1.BN(duration), [...metadataUrlBuf])
                .accounts({
                distribution,
                payer: this.provider.wallet.publicKey,
                authority,
                systemProgram: anchor_1.web3.SystemProgram.programId,
            })
                .rpc();
            for (const mint of metadata.mints) {
                console.log(mint);
                const mintPubkey = new anchor_1.web3.PublicKey(mint.address);
                const vault = anchor_1.web3.PublicKey.findProgramAddressSync([
                    Buffer.from('Vault'),
                    distribution.toBuffer(),
                    mintPubkey.toBuffer(),
                ], this.programId)[0];
                yield this.program.methods
                    .vaultCreate()
                    .accounts({
                    distribution,
                    vault,
                    mint: mintPubkey,
                    payer: this.provider.wallet.publicKey,
                    tokenProgram: Token.TOKEN_PROGRAM_ID,
                    associatedTokenProgram: Token.ASSOCIATED_TOKEN_PROGRAM_ID,
                    systemProgram: anchor_1.web3.SystemProgram.programId,
                    rent: anchor_1.web3.SYSVAR_RENT_PUBKEY,
                })
                    .rpc();
            }
        });
    }
    editDistribution() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    closeDistribution(number) {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
}
exports.MangoMintsRedemptionClient = MangoMintsRedemptionClient;
